unit Main;


{$IFDEF VER220}
  {$define DELPHI2009UP}
{$endif}

{$IFDEF VER210}
  {$define DELPHI2009UP}
{$endif}

{$IFDEF VER200}
  {$define DELPHI2009UP}
{$endif}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ZylGPSReceiver, ComCtrls, ExtCtrls,
  ZylCustomGPSReceiver;

type
  TfrmMain = class(TForm)
    btnStart: TButton;
    btnStop: TButton;
    ZylGPSReceiver: TZylGPSReceiver;
    memRaw: TMemo;
    GroupBox1: TGroupBox;
    efLatDeg: TEdit;
    Label1: TLabel;
    efLatMin: TEdit;
    Label2: TLabel;
    efLatSec: TEdit;
    Label3: TLabel;
    efLatDir: TEdit;
    Label4: TLabel;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    efLongDeg: TEdit;
    efLongMin: TEdit;
    efLongSec: TEdit;
    efLongDir: TEdit;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    efAlt: TEdit;
    efSpeed: TEdit;
    efHeading: TEdit;
    efSatCount: TEdit;
    Label13: TLabel;
    lstPort: TListBox;
    Label15: TLabel;
    Label16: TLabel;
    lblUTCTime: TLabel;
    lblLocalTime: TLabel;
    PaintBox: TPaintBox;
    btnUpload: TButton;
    GroupBox4: TGroupBox;
    Label14: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    efSignal: TEdit;
    efSNR: TEdit;
    efFrq: TEdit;
    efDataRate: TEdit;
    btnDetect: TButton;
    lstBaudRate: TListBox;
    lblDetect: TLabel;
    btnCancelDetect: TButton;
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure ZylGPSReceiverSpeedChange(Sender: TObject; Value: Extended);
    procedure ZylGPSReceiverHeadingChange(Sender: TObject; Value: Extended);
    procedure ZylGPSReceiverConnect(Sender: TObject; Port: TCommPort);
    procedure ZylGPSReceiverDisconnect(Sender: TObject; Port: TCommPort);
    procedure ZylGPSReceiverAltitudeChange(Sender: TObject; Value: Extended);
    procedure ZylGPSReceiverLatitudeChange(Sender: TObject; Degree,
      Minute: Integer; Second: Extended; Direction: TCardinalPoint);
    procedure ZylGPSReceiverLongitudeChange(Sender: TObject; Degree,
      Minute: Integer; Second: Extended; Direction: TCardinalPoint);
    procedure ZylGPSReceiver2DPositionChange(Sender: TObject; Latitude,
      Longitude: Extended);
    procedure ZylGPSReceiver3DPositionChange(Sender: TObject; Latitude,
      Longitude, Altitude: Extended);
    procedure ZylGPSReceiverSatelliteReceive(Sender: TObject;
      Satellite: TSatellite);
    procedure PaintBoxPaint(Sender: TObject);
    procedure ZylGPSReceiverSatellitesReceive(Sender: TObject);
    procedure btnUploadClick(Sender: TObject);
    procedure btnDetectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ZylGPSReceiverDetect(Sender: TObject; Port: TCommPort;
      BaudRate: TBaudRate; var Cancel: Boolean);
    procedure btnCancelDetectClick(Sender: TObject);
    {$IFDEF DELPHI2009UP}
    procedure ZylGPSReceiverUnknownCommand(Sender: TObject;
      Command: AnsiString);
    {$ELSE}
    procedure ZylGPSReceiverUnknownCommand(Sender: TObject;
      Command: String);
    {$ENDIF}

    {$IFDEF DELPHI2009UP}
    procedure ZylGPSReceiverReceive(Sender: TObject; Buffer: AnsiString);
    {$ELSE}
    procedure ZylGPSReceiverReceive(Sender: TObject; Buffer: String);
    {$ENDIF}

    procedure ZylGPSReceiverIdle(Sender: TObject);
    procedure ZylGPSReceiverTimeout(Sender: TObject);
    procedure ZylGPSReceiverArrival(Sender: TObject; const Waypoint: TWayPoint; const IsCircleEntered: Boolean;
      const IsPerpendicularPassed: Boolean);
    procedure ZylGPSReceiverWayPointReceive(Sender: TObject;
      const WayPoint: TWayPoint);


  private
    { Private declarations }
    FCancelDetect: Boolean;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.btnStartClick(Sender: TObject);
begin
  ZylGPSReceiver.Port := TCommPort(lstPort.ItemIndex + 1);
  ZylGPSReceiver.BaudRate := ZylGPSReceiver.IntToBaudRate(StrToInt(lstBaudRate.Items[lstBaudRate.ItemIndex]));  
  ZylGPSReceiver.Open;
end;

procedure TfrmMain.btnStopClick(Sender: TObject);
begin
  ZylGPSReceiver.Close;
end;

procedure TfrmMain.ZylGPSReceiverSpeedChange(Sender: TObject; Value: Extended);
begin
  memRaw.Lines.Add('Speed Changed:' + FloatToStr(Value) + ' KM/H');
end;

procedure TfrmMain.ZylGPSReceiverHeadingChange(Sender: TObject;
  Value: Extended);
begin
  memRaw.Lines.Add('Heading Changed:' + FloatToStr(Value) + ' Degrees');
end;

procedure TfrmMain.ZylGPSReceiverConnect(Sender: TObject; Port: TCommPort);
begin
  memRaw.Lines.Add('Connected to:' + ZylGPSReceiver.CommPortToString(Port));
end;

procedure TfrmMain.ZylGPSReceiverDisconnect(Sender: TObject;
  Port: TCommPort);
begin
  memRaw.Lines.Add('Disconnected from:' + ZylGPSReceiver.CommPortToString(Port));
end;

procedure TfrmMain.ZylGPSReceiverAltitudeChange(Sender: TObject;
  Value: Extended);
begin
  memRaw.Lines.Add('Altitude Changed:' + FloatToStr(Value) + ' M');
end;

procedure TfrmMain.ZylGPSReceiverLatitudeChange(Sender: TObject; Degree,
  Minute: Integer; Second: Extended; Direction: TCardinalPoint);
begin
  memRaw.Lines.Add('Latitude Changed: ' + FloatToStr(ZylGPSReceiver.DMSToDecimalDegrees(Degree, Minute, Second, Direction)));
end;

procedure TfrmMain.ZylGPSReceiverLongitudeChange(Sender: TObject; Degree,
  Minute: Integer; Second: Extended; Direction: TCardinalPoint);
begin
  memRaw.Lines.Add('Longitude Changed: ' + FloatToStr(ZylGPSReceiver.DMSToDecimalDegrees(Degree, Minute, Second, Direction)));
end;

procedure TfrmMain.ZylGPSReceiver2DPositionChange(Sender: TObject;
  Latitude, Longitude: Extended);
begin
  memRaw.Lines.Add('2D Position Changed. Distance to New York City = ' + FloatToStr(ZylGPSReceiver.Distance_Km(Latitude, Longitude, 40.77, 73.98)) + ' KM');
end;

procedure TfrmMain.ZylGPSReceiver3DPositionChange(Sender: TObject;
  Latitude, Longitude, Altitude: Extended);
begin
  memRaw.Lines.Add('3D Position Changed.');
end;

procedure TfrmMain.ZylGPSReceiverSatelliteReceive(Sender: TObject;
  Satellite: TSatellite);
var
  str: AnsiString;
begin
  str := 'Satellite Received' + ' Code=' + IntToStr(Satellite.PseudoRandomCode);
  str := str + ' Elevation=' + IntToStr(Satellite.Elevation);
  str := str + ' Azimuth=' + IntToStr(Satellite.Azimuth);
  str := str + ' Signal=' + IntToStr(Satellite.SignalToNoiseRatio);
  memRaw.Lines.Add(str);
end;

procedure TfrmMain.PaintBoxPaint(Sender: TObject);
begin
  ZylGPSReceiver.DrawSatellites(PaintBox.Canvas, PaintBox.Width div 2,
    clBlack, clWhite);
end;

procedure TfrmMain.ZylGPSReceiverSatellitesReceive(Sender: TObject);
begin
  PaintBox.Repaint;
end;

procedure TfrmMain.btnUploadClick(Sender: TObject);
var
  wp1, wp2: TWayPoint;
  rt: TRoute;
begin
  wp1 := TWayPoint.Create;
  wp1.Name := 'WP1';
  wp1.Latitude_Degree := 46;
  wp1.Latitude_Minute := 45;
  wp1.Latitude_Second := 6;
  wp1.Latitude_Direction := cpNorth;
  wp1.Longitude_Degree := 23;
  wp1.Longitude_Minute := 33;
  wp1.Longitude_Second := 19;
  wp1.Longitude_Direction := cpEast;

  wp2 := TWayPoint.Create;
  wp2.Name := 'WP2';
  wp2.Latitude_Degree := 46;
  wp2.Latitude_Minute := 46;
  wp2.Latitude_Second := 6;
  wp2.Latitude_Direction := cpNorth;
  wp2.Longitude_Degree := 23;
  wp2.Longitude_Minute := 34;
  wp2.Longitude_Second := 19;
  wp2.Longitude_Direction := cpEast;

  rt := TRoute.Create;
  rt.Name := '0';
  rt.WayPoints.Add(wp1.Name);
  rt.WayPoints.Add(wp2.Name);

  ZylGPSReceiver.UploadWaypoint(wp1);
  ZylGPSReceiver.UploadWaypoint(wp2);

  ZylGPSReceiver.UploadRoute(rt);

  wp1.Free;
  wp2.Free;
  rt.Free;
end;

procedure TfrmMain.btnDetectClick(Sender: TObject);
var
  pPort: TCommPort;
  pBaudRate: TBaudRate;
begin
  FCancelDetect := False;
  if ZylGPSReceiver.DetectGPS(pPort, pBaudRate) then
  begin
    ShowMessage('Detected: ' + ZylGPSReceiver.CommPortToString(pPort) +
      ' BaudRate = ' + IntToStr(ZylGPSReceiver.BaudRateToInt(pBaudRate)));
    lstPort.ItemIndex := lstPort.Items.IndexOf(ZylGPSReceiver.CommPortToString(pPort));
    lstBaudRate.ItemIndex := lstBaudRate.Items.IndexOf(IntToStr(ZylGPSReceiver.BaudRateToInt(pBaudRate)));
  end
  else
  begin
    ShowMessage('No GPS detected.');
  end;
  lblDetect.Caption := '';
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  lstBaudRate.ItemIndex := 9;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ZylGPSReceiver.IsConnected <> spNone then
    ZylGPSReceiver.Close();
end;

procedure TfrmMain.ZylGPSReceiverDetect(Sender: TObject; Port: TCommPort;
  BaudRate: TBaudRate; var Cancel: Boolean);
begin
  lblDetect.Caption := 'Detecting - Port: ' + ZylGPSReceiver.CommPortToString(Port) +
      ' BaudRate: ' + IntToStr(ZylGPSReceiver.BaudRateToInt(BaudRate));
  Cancel := FCancelDetect;    
end;

procedure TfrmMain.btnCancelDetectClick(Sender: TObject);
begin
  FCancelDetect := True;
end;

{$IFDEF DELPHI2009UP}
procedure TfrmMain.ZylGPSReceiverUnknownCommand(Sender: TObject;
  Command: AnsiString);
{$ELSE}
procedure TfrmMain.ZylGPSReceiverUnknownCommand(Sender: TObject;
  Command: String);
{$ENDIF}
begin
  memRaw.Lines.Add('Unknown Command: ' + Command);
end;

procedure TfrmMain.ZylGPSReceiverIdle(Sender: TObject);
begin
  memRaw.Lines.Add('Idle!');
end;

procedure TfrmMain.ZylGPSReceiverTimeout(Sender: TObject);
begin
  memRaw.Lines.Add('Timeout!');
end;

procedure TfrmMain.ZylGPSReceiverArrival(Sender: TObject;
  const Waypoint: TWayPoint; const IsCircleEntered: Boolean; const IsPerpendicularPassed: Boolean);
begin
  memRaw.Lines.Add('Arrival: ' + WayPoint.Name);
end;

{$IFDEF DELPHI2009UP}
procedure TfrmMain.ZylGPSReceiverReceive(Sender: TObject; Buffer: AnsiString);
{$ELSE}
procedure TfrmMain.ZylGPSReceiverReceive(Sender: TObject; Buffer: String);
{$ENDIF}
begin
  efLatDeg.Text := IntToStr(ZylGPSReceiver.GetLatitudeDegree);
  efLatMin.Text := IntToStr(ZylGPSReceiver.GetLatitudeMinute);
  efLatSec.Text := FloatToStr(ZylGPSReceiver.GetLatitudeSecond);
  if ZylGPSReceiver.GetLatitudeDirection = cpNorth then
    efLatDir.Text := 'North'
  else
    efLatDir.Text := 'South';

  efLongDeg.Text := IntToStr(ZylGPSReceiver.GetLongitudeDegree);
  efLongMin.Text := IntToStr(ZylGPSReceiver.GetLongitudeMinute);
  efLongSec.Text := FloatToStr(ZylGPSReceiver.GetLongitudeSecond);
  if ZylGPSReceiver.GetLongitudeDirection = cpEast then
    efLongDir.Text := 'East'
  else
    efLongDir.Text := 'West';

  efAlt.Text := FloatToStr(ZylGPSReceiver.GetAltitude);
  efSpeed.Text := FloatToStr(ZylGPSReceiver.GetSpeed_KMH);
  efHeading.Text := FloatToStr(ZylGPSReceiver.GetHeading);
  efSatCount.Text := IntToStr(ZylGPSReceiver.GetSatelliteCount);

  lblUTCTime.Caption := DateTimeToStr(ZylGPSReceiver.GetUTCDateTime);
  lblLocalTime.Caption := DateTimeToStr(ZylGPSReceiver.GetLocalDateTime);

  try
    efSignal.Text := FloatToStr(ZylGPSReceiver.GetReceiverStatus.SignalStrength);
    efSNR.Text := FloatToStr(ZylGPSReceiver.GetReceiverStatus.SNR);
    efFrq.Text := FloatToStr(ZylGPSReceiver.GetReceiverStatus.Frequency);
    efDataRate.Text := FloatToStr(ZylGPSReceiver.GetReceiverStatus.DataRate);
  except
  end;

  try
    memRaw.Lines.Add(Buffer);
    memRaw.Lines.Add('Fix = ' + IntToStr(ZylGPSReceiver.IsFix));
    memRaw.Lines.Add('---------------------------------------------------------')
  except
    memRaw.Lines.Clear;
  end;

  memRaw.Lines.Add('HDOP = ' + FloatToStr(ZylGPSReceiver.GetHDOP));
  memRaw.Lines.Add('VDOP = ' + FloatToStr(ZylGPSReceiver.GetVDOP));
  memRaw.Lines.Add('PDOP = ' + FloatToStr(ZylGPSReceiver.GetPDOP));
end;

procedure TfrmMain.ZylGPSReceiverWayPointReceive(Sender: TObject;
  const WayPoint: TWayPoint);
begin
  memRaw.Lines.Add('WayPoint Received: ' + WayPoint.Name);
end;

end.
